// 该类 Task 继承自 Node 类，是一个表示任务的类，可能用于任务管理和同步操作
public class Task extends Node {
    // 日志标签，使用类的简单名称
    private static final String TAG = Task.class.getSimpleName();
    // 标记任务是否完成
    private boolean mCompleted;
    // 任务的笔记信息
    private String mNotes;
    // 任务的元信息，存储为 JSONObject
    private JSONObject mMetaInfo;
    // 任务的前一个兄弟任务
    private Task mPriorSibling;
    // 任务所属的任务列表
    private TaskList mParent;


    // 构造函数，初始化任务的属性
    public Task() {
        super();
        mCompleted = false;
        mNotes = null;
        mPriorSibling = null;
        mParent = null;
        mMetaInfo = null;
    }


    // 获取创建操作的 JSON 对象
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();


        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);


            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);


            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mParent.getChildTaskIndex(this));


            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_TASK);
            if (getNotes()!= null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);


            // parent_id
            js.put(GTaskStringUtils.GTASK_JSON_PARENT_ID, mParent.getGid());


            // dest_parent_type
            js.put(GTaskStringUtils.GTASK_JSON_DEST_PARENT_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);


            // list_id
            js.put(GTaskStringUtils.GTASK_JSON_LIST_ID, mParent.getGid());


            // prior_sibling_id
            if (mPriorSibling!= null) {
                js.put(GTaskStringUtils.GTASK_JSON_PRIOR_SIBLING_ID, mPriorSibling.getGid());
            }


        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-create jsonobject");
        }


        return js;
    }


    // 获取更新操作的 JSON 对象
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();


        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);


            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);


            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());


            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            if (getNotes()!= null) {
                entity.put(GTaskStringUtils.GTASK_JSON_NOTES, getNotes());
            }
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);


        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate task-update jsonobject");
        }


        return js;
    }


    // 根据远程的 JSON 对象设置任务的内容
    public void setContentByRemoteJSON(JSONObject js) {
        if (js!= null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }


                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }


                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }


                // notes
                if (js.has(GTaskStringUtils.GTASK_JSON_NOTES)) {
                    setNotes(js.getString(GTaskStringUtils.GTASK_JSON_NOTES));
                }


                // deleted
                if (js.has(GTaskStringUtils.GTASK_JSON_DELETED)) {
                    setDeleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_DELETED));
                }


                // completed
                if (js.has(GTaskStringUtils.GTASK_JSON_COMPLETED)) {
                    setCompleted(js.getBoolean(GTaskStringUtils.GTASK_JSON_COMPLETED));
                }
            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get task content from jsonobject");
            }
        }
    }


    // 根据本地的 JSON 对象设置任务的内容
    public void setContentByLocalJSON(JSONObject js) {
        if (js == null ||!js.has(GTaskStringUtils.META_HEAD_NOTE)
                ||!js.has(GTaskStringUtils.META_HEAD_DATA)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }


        try {
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);


            if (note.getInt(NoteColumns.TYPE)!= Notes.TYPE_NOTE) {
                Log.e(TAG, "invalid type");
                return;
            }


            for (int i = 0; i < dataArray.length(); i++) {
                JSONObject data = dataArray.getJSONObject(i);
                if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                    setName(data.getString(DataColumns.CONTENT));
                    break;
                }
            }


        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }


    // 从任务的内容获取本地的 JSON 对象
    public JSONObject getLocalJSONFromContent() {
        String name = getName();
        try {
            if (mMetaInfo == null) {
                // 新创建的任务
                if (name == null) {
                    Log.w(TAG, "the note seems to be an empty one");
                    return null;
                }


                JSONObject js = new JSONObject();
                JSONObject note = new JSONObject();
                JSONArray dataArray = new JSONArray();
                JSONObject data = new JSONObject();
                data.put(DataColumns.CONTENT, name);
                dataArray.put(data);
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
                return js;
            } else {
                // 已同步的任务
                JSONObject note = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
                JSONArray dataArray = mMetaInfo.getJSONArray(GTaskStringUtils.META_HEAD_DATA);


                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    if (TextUtils.equals(data.getString(DataColumns.MIME_TYPE), DataConstants.NOTE)) {
                        data.put(DataColumns.CONTENT, getName());
                        break;
                    }
                }


                note.put(NoteColumns.TYPE, Notes.TYPE_NOTE);
                return mMetaInfo;
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }


    // 设置任务的元信息
    public void setMetaInfo(MetaData metaData) {
        if (metaData!= null && metaData.getNotes()!= null) {
            try {
                mMetaInfo = new JSONObject(metaData.getNotes());
            } catch (JSONException e) {
                Log.w(TAG, e.toString());
                mMetaInfo = null;
            }
        }
    }


    // 获取同步操作的状态
    public int getSyncAction(Cursor c) {
        try {
            JSONObject noteInfo = null;
            if (mMetaInfo!= null && mMetaInfo.has(GTaskStringUtils.META_HEAD_NOTE)) {
                noteInfo = mMetaInfo.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            }


            if (noteInfo == null) {
                Log.w(TAG, "it seems that note meta has been deleted");
                return SYNC_ACTION_UPDATE_REMOTE;
            }


            if (!noteInfo.has(NoteColumns.ID)) {
                Log.w(TAG, "remote note id seems to be deleted");
                return SYNC_ACTION_UPDATE_LOCAL;
            }


            // 验证笔记的 ID
            if (c.getLong(SqlNote.ID_COLUMN)!= noteInfo.getLong(NoteColumns.ID)) {
                Log.w(TAG, "note id doesn't match");
                return SYNC_ACTION_UPDATE_LOCAL;
            }


            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 本地没有更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 两边都没有更新
                    return SYNC_ACTION_NONE;
                } else {
                    // 将远程更新应用到本地
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // 验证 gtask 的 ID
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 仅本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    return SYNC_ACTION_UPDATE_CONFLICT;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }


        return SYNC_ACTION_ERROR;
    }


    // 判断任务是否值得保存
    public boolean isWorthSaving() {
        return mMetaInfo!= null || (getName()!= null && getName().trim().length() > 0)
                || (getNotes()!= null && getNotes().trim().length() > 0);
    }


    // 设置任务完成状态
    public void setCompleted(boolean completed) {
        this.mCompleted = completed;
    }


    // 设置任务的笔记信息
    public void setNotes(String notes) {
        this.mNotes = notes;
    }


    // 设置任务的前一个兄弟任务
    public void setPriorSibling(Task priorSibling) {
        this.mPriorSibling = priorSibling;
    }


    // 设置任务的父任务列表
    public void setParent(TaskList parent) {
        this.mParent = parent;
    }


    // 获取任务完成状态
    public boolean getCompleted() {
        return this.mCompleted;
    }


    // 获取任务的笔记信息
    public String getNotes() {
        return this.mNotes;
    }


    // 获取任务的前一个兄弟任务
    public Task getPriorSibling() {
        return this.mPriorSibling;
    }


    // 获取任务的父任务列表
    public TaskList getParent() {
        return this.mParent;
    }
}